;;; Subroutine: accumulate_buffer
;;; Accumulate the data in a 2000 word buffer placed from
;;; address $1000 and forth. Return the sum i R0
;;; Note that the base address and buffer size is placed
;;; in memory. These values are to large to be used as
;;; immediate values.
	
baseaddr:	.word $1000
bufsize:	.word  2000
	
accumulate_buffer:
        push(r3)     ; Save state of registers
        push(r2)     ;  "
        push(r1)     ;  "
        push(g0)     ;  "

	g0 = mem(baseaddr)
	r1 = g0	     ; Buffer base address
	g0 = mem(bufsize)
        r2 = g0      ; Loop counter
        r0 = 0       ; Accumulation register
loop:   r3=mem(r1)   ; load data element
        r1++         ; update buffer pointer
        r0=r0+r3     ; accumulate data in register
        r2--         ; update loop counter
        jumpnz loop  ; if loop counter /= 0 repeat

	g0 = pop()
	r1 = pop()   ; Restore state of registers
        r2 = pop()   ;  "
        r3 = pop()   ;  "
        rtn          ; return accumulated value in R0
