;;; Subroutine crcb
;;; Calculates a CRC check word on data read on the fifo register.
;;; The routine take one argument in R0, specifying the number of bytes
;;; to check.
;;; The routine returns the CRC checkword in G0        

crclut: .word crcLookupTable
        ;; Calling point fo the crc calculation
crcb:
        push(r1)                ; store the state of the registers
        push(r2)                ; "
        push(r3)                ; "

        g0 = mem(crclut)        ; Load pointer to crc table
        r1 = 0

crcloop:
        r3 = popfifo(7)         ; Read new byte
        r2 = r1 >> 8            ; 8 MSB's of CRC (x^15 + ... + X^8) 
        r3 = r3 xor r2          ; Sum between CRC og new byte in binary field
        r2 = mem( g0 + r3 )     ; 
        r1 = r1 << 8            ; s0*x^8+s1*x^9+...+s7*x^15
        r1 = r1 xor r2          ; 
        r0--                    ; update counter
        jumpnz crcloop          ; if counter!=0 then jump
        g0 = r1                 ; move crc to g0

        r3 = pop()
        r2 = pop()
        r1 = pop()
        rtn

#include crc-lookup-tables
