#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

FILE *pctrace,*sym,*profile;
int pcoccur[1<<16];
float histogram[1<<16];
float value;

int main(int argc, char *argv[])
{
  int counter;
  int pc;
  int lines=0;
  int endflag=0;

  char pctracefile[256],profilefile[256],symfile[256];
  char linestr[1024];

  if ((argc!=4))
    {
      fprintf(stderr,"USAGE: bspprof tracefile symfile outputfile\n");
      exit(1);
    }
  
  sprintf(pctracefile,"%s",argv[1]);
  sprintf(symfile,"%s",argv[2]);
  sprintf(profilefile,"%s",argv[3]);
  
/*   printf("files: %s %s %s\n",pctracefile,symfile,profilefile); */

  pctrace=fopen(pctracefile, "r");
  if(!pctrace)
    {
      fprintf(stderr,"Could not open pc trace file: %s\n",pctracefile);
      exit(1);
    }

  sym=fopen(symfile, "r");
  if(!sym)
    {
      fprintf(stderr,"Could not open sym file: %s\n",symfile);
      exit(1);
    }
  
  profile=fopen(profilefile,"w");
  if(!profile)
    {
      fprintf(stderr,"Could not open profil file:%s\n",profilefile);
      exit(1);
    }

  for (counter=0;counter<(1<<16);counter++)
    {
      histogram[counter]=0.0;
      pcoccur[counter]=0;
    }

  while (1==fscanf(pctrace,"%d",&pc))
    {
      pcoccur[pc]++;
      lines++;
    }
    
  for (counter=0;counter<(1<<16);counter++)
    {
      histogram[counter]=100.0*((float)pcoccur[counter])/((float)lines);
    }

  


  do
  {
      counter=-1;
      do
	linestr[++counter]=getc(sym);
      while ((linestr[counter]!='\n') && (linestr[counter]!=EOF));

      if (linestr[counter]==EOF)
	endflag=1;
      linestr[counter]='\0';

      counter=0;
      while ((linestr[counter]!='[') && 
	     (linestr[counter]!='\n') && 
	     (linestr[counter]==' '))
	counter++;

      if (linestr[counter]=='[')
	{
 	  /*pc=atoi(&linestr[counter+1]);*/
	  sscanf(&linestr[counter+1],"%X",&pc);
	  value=histogram[pc];
	}
      else
	value=0.0;
      
      if (value>=0.01)
	fprintf(profile,"%6.2f %% :  %s\n",value,linestr);
      else
	fprintf(profile,"         :  %s\n"      ,linestr);
	
  }  while (endflag==0);

  fclose(pctrace);
  fclose(sym);
  fclose(profile);
  return 0;
}

